/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Jabatan;
import com.portofolio.entity.vo.JabatanId;

@Lazy
@Repository("jabatanDao")
public interface JabatanDao extends CrudRepository<Jabatan, JabatanId> {
    

    @Query(QListAll)
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    @Query(QListAll + " and model.namaJabatan like %:namaJabatan% ")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaJabatan") String namaJabatan, @Param("statusEnabled") boolean statusEnabled,Pageable page);
    
    @Query(QListAll + " and model.id.kdJabatan = :kdJabatan")
    Map<String, Object> findByKdJabatan(@Param("kdProfile") Integer kdProfile, @Param("kdJabatan") String kdJabatan,@Param("statusEnabled") boolean statusEnabled);
       
    
    String QListAll ="select new map(model.id.kdJabatan as kdJabatan,model.id.kdProfile as kdProfile "
            + ", model.namaJabatan as namaJabatan " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.noUrut as noUrut " 
            + ", model.kdJabatanHead as kdJabatanHead "
            + ", jabatanHead.namaJabatan as namaJabatanHead" 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec, model.version as version )" 
            + " from Jabatan model left join model.id id "
            + "left join model.jabatanHead jabatanHead "
            + "where id.kdProfile=:kdProfile and model.statusEnabled=:statusEnabled ";
  
	    
}
